////////////////////////////////////////////////////////////////////////////////
// WWWBtn97.PAS                                                               //
////////////////////////////////////////////////////////////////////////////////
// This component is a DropDown Button, which display all the Internet        //
// Explorer (3.0 & 4.0) Favorite with a PopupMenu.                            //
// The PopupMenu is displayed with Office97 style (Glyph on MenuItem).        //
////////////////////////////////////////////////////////////////////////////////
// Version 1.4                                                                //
// Created     : 10/07/1997                                                   //
// Last Update : 01/10/1997                                                   //
////////////////////////////////////////////////////////////////////////////////
// Stphane Chova                     E-Mail : stephane.chova@hol.fr          //
//                                    WWW    : http://wwwperso.hol.fr/~schova //
////////////////////////////////////////////////////////////////////////////////
// NOTES : This component is a FreeWare (With source).                        //
//         If you want to use a part or all the component source, you must    //
//         only tell me it. If you like this component, you can send me a     //
//         postcard at this adress : Mr CHOVA Stphane                        //
//                                   3, Alle Ren CLAIR                      //
//                                   13500 Martigues                          //
//                                   FRANCE                                   //
////////////////////////////////////////////////////////////////////////////////
// WANTED : For last update, i research a document which explain the NETSCAPE //
//          Favorites.                                                        //
//          If you have this information, please send me it by E-Mail.
////////////////////////////////////////////////////////////////////////////////
// REVISIONS : Rev .4                                                         //
//                                                                            //
//     - Fix No Favorites folder bug .                                        //
//       (Thanks to Mike Riley for have report this bug).                     //
//     - Add Color Property (Background Color of the Button).                 //
//       (Thanks to Andy Chentsov for to have add this property)              //
//     - Add Caption Property (For Main Button).                              //
//     - Add Layout Property (For Glyph & Caption position on Main Button).   //
//     - Add Font Property (For Caption's Main Button).                       //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
unit WWWBtn97;

interface
{$R *.DCR}
uses
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
    Dialogs, ExtCtrls, Menus, ComCtrls,Registry,inifiles, stdctrls;

Const
     // Differents state of MainButton.
     Normal      = 0;
     NoSel       = 1;
     LeftDown    = 2;
     RightDown   = 3;

Type
    // List of pointer for Favorite's links record.
    TURLrec = Class
      Rep      : String;
      URLName  : String;
      URLPath  : String;
    end;

Type
    { TMenuOption Property Editor }
    TMenuStyle = (Standard, Extended);             // Menu Type.
    TBorderStyle = (bsNone,bsRaised,bsLowered);    // Border Style.
    TURLDisplay = (Only_one_icon, All_icon);
    TMenuOption = Class(TPersistent)
      Private
        {Private Declaration}
        FURLDisplay        : TURLDisplay;
        FStyle             : TMenuStyle;    //Style Of PopupMenu.
        FBorderStyle       : TBorderStyle;
        FItemBmpFolder,
        FItemBmpURL        : TBitmap;       //Items Bitmap.
        FItemColorSelect,                   //Item Select state Color.
        FItemColorUnSelect : TColor;        //Item Unselect state Color.
        FItemFont          : TFont;         //Items Font Style.
        FFontSelectColor   : Tcolor;
        // Display url Icon Mode.
        Procedure SetURLDisplay(Value : TURLDisplay);
        Function GetURLDisplay : TURLDisplay;
        // Set Bitmap for items URL & Folder.
        Procedure SetItemBmpFolder(Value : TBitmap);
        Procedure SetItemBmpURL(Value : TBitmap);
        // Set & get procedure for PoupMenu Style.
        Procedure SetStyle(Value : TMenuStyle);
        Function GetStyle : TMenuStyle;
        // Set & get procedure for MenuItem Border Style.
        Procedure SetBorderStyle(Value : TBorderStyle);
        Function GetBorderStyle : TBorderStyle;
        // Set Item Font.
        Procedure SetItemFont (value : Tfont);
      Published
        {Published declaration}
        Property FontItem          : TFont Read FItemFont Write SetItemFont;
        Property FontColorSelect   : TColor Read FFontSelectColor Write FFontSelectColor;
        Property ItemBmpFolder     : TBitmap Read FItemBmpFolder Write SetItemBmpFolder;
        Property ItemBmpURL        : TBitmap Read FItemBmpURL Write SetItemBmpURL;
        Property ItemSelectColor   : TColor Read FItemColorSelect Write FItemColorSelect;
        Property ItemUnselectColor : TColor Read FItemColorUnSelect Write FItemColorUnSelect;
        Property ItemBorderStyle   : TBorderStyle Read GetBorderStyle Write SetBorderStyle;
        Property MenuStyle         : TMenuStyle Read GetStyle Write SetStyle;
        Property URLBitmapDisplay  : TURLDisplay Read GetURLDisplay Write SetURLDisplay;
    end;

Type
    { TWWWBtn97}
    TLayout = (GlyphTop,GlyphBottom,GlyphLeft,GlyphRight);
    TWWWBtn97 = class(TCustomControl)
      private
         {Private Declaration}
         WMenu            : TPopupMenu;  // PopupMenu showing the list.
         NewItem,subItem,
         DirItem          : TMenuItem;   // Item of PopupMenu.
         HasMouse,                       // Loop for detect the mouse.
         StillDown,                      // State selected for MainButton (Left & Right).
         MainButton       : Boolean;     // Main button.
         RectB,                           // Rect of button.
         RectL,                          // Rect of left button.
         RectR            : TRect;       // Rect of Right button.
         RightWidth       : Integer;     // Width of right button.
         Registry         : TRegistry;   // register var for operations in RegEdit.
         Orig_Folder      : String;      // Main path of the favorites.
         FDefaultMargin,                 // Default Margin for all Menu-items.
         FDefaultHeight,                 // Default Height for all Menu-items.
         FItemHeight,                    // Menu-item height.
         FItemWidth       : Integer;     // Menu-item Width.
         FURLName,                       // Temp property value (URLName).
         FURLPath         : String;      // Temp property value (URLPath).
         FOnSelectURL     : TNotifyEvent;// Event of selected PopupMenu item.
         sList            : TList;       // list of pointer.
         tempObj          : TURLrec;     // Temp Pointer.
         FGlyph           : TBitmap;     // Icon for mainbutton.
         ModifFlag        : Boolean;
         FMenu            : TMenuOption; // Temp var for TMenuOption Property.
         OffsetWidth      : Integer;
         ImageList        : TImageList; // ImageList for Mainbutton's Glyph.
         tmpBmp           : TBitmap;    // For Mainbutton's Glyph.
         FLayout          : TLayout;
         // Draw caption of the mainButton.
         Procedure DrawCaption (Layout : TLayout ; Mode : Boolean);
         // Draw Glyph of the mainButton. ("Enabled" State)
         procedure DrawGlyph (Canvas:TCanvas; bmp:TBitmap; x,y:Integer);
         // Draw Glyph of the mainButton. ("Disabled" State)
         procedure DrawGrayGlyph (Canvas: TCanvas; bmp: TBitmap; x, y: Integer);
         // Draw poupMark on the right parts of the mainbutton.
         Procedure DrawPopupMark (state : Boolean);
         // Draw MainButton Border.
         Procedure DrawBtn (Mode : Byte);
         // Set Glyph for MainButton.
         procedure SetGlyph (Value : TBitmap);
         // Set & Get Layout procedure.
         Procedure SetLayout (Value : TLayout);
         Function GetLayout : TLayout;

         // PopupMenu Message.
         Procedure WMCommand(Var Message : TWMCommand); Message WM_COMMAND;
         Procedure WMDrawItem(var Message: TWMDrawItem); message WM_DRAWITEM;
         Procedure WMMeasureItem(var Message: TWMMeasureItem); message WM_MEASUREITEM;
          // Mouse Message.
         Procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
         Procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
         // Button Message (in the DELPHI IDE).
         Procedure CMEnabledChanged(var Msg: TMessage); message CM_ENABLEDCHANGED;
         Procedure CMTextChanged(var Msg: TMessage); message CM_TEXTCHANGED;
         Procedure CMFontChanged(var Msg: TMessage); message CM_FONTCHANGED;
      protected
         // Change PopupMenu state in OWNERDRAW.
         procedure ModifyMenuTree(MenuItems : TMenuItem);
         Function  CalcMenuWidth(Item : TMenuItem) : Integer;
         Procedure CalcHeightItem;
         // Set all pointer list & Menu config.
         Procedure CreateMenu;
         Function CreateSubMenu : Boolean;
         Procedure SearchURL(Folder : String);
         // Mouse event for Main Button.
         Procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
         Procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
         // OnSelected Event of PopupMenu.
         Procedure SelectUrl;
         // Refresh the favorites List.
         Procedure ActuListe;
      public
         {Public declaration}
         Constructor Create(AOwner: TComponent); override;
         Destructor  Destroy; override;
         Procedure   Paint; Override;
      published
         {Published declaration}
         Property Align;       // All component's property.
         Property Caption;
         Property Color;
         Property Cursor;
         Property Enabled;
         property Font;
         Property GlyphButton : Tbitmap read FGlyph write SetGlyph;
         Property Height;
         Property HelpContext;
         Property Hint;
         Property Layout : TLayout Read GetLayout Write SetLayout;
         Property Left;
         Property MenuOptions : TMenuOption Read Fmenu Write FMenu;
         Property ParentShowHint;
         Property ShowHint;
         Property TabOrder;
         Property TabStop;
         Property Tag;
         Property Top;
         Property URLName : String read FURLName write FURLName;
         Property URLPath : String read FURLPath write FURLPath;
         Property Visible;
         Property Width;
         Property OnSelectURL : TNotifyEvent read FOnSelectUrl write FOnSelectUrl;
End;
    Function SortFunction(item1,item2:Pointer):Integer;
    Procedure Register;

implementation


{ TMenuOption }

{ Set Item Bitmap for "Folder" line. }
Procedure TMenuOption.SetItemBmpFolder(Value:TBitmap);
begin
     FItemBmpFolder.Assign(Value);
end;

{ Set Item Bitmap for "URL" line. }
Procedure TMenuOption.SetItemBmpURL(Value:TBitmap);
begin
     FItemBmpURL.Assign(Value);
end;

{ Set Item Font.}
procedure TMenuOption.SetItemFont(Value: TFont);
begin
     FItemFont.Assign(Value);
end;

{ Set PopupMenu Style.}
Procedure TMenuOption.SetBorderStyle(Value:TBorderStyle);
begin
     if FBorderstyle<>value then FBorderstyle:=value;
end;

{ Get PoupMenu Style. }
Function TMenuOption.GetBorderStyle :TBorderStyle;
begin
     Result:=TBorderStyle(FBorderStyle);
end;

{ Set PopupMenu Style. }
Procedure TMenuOption.SetStyle(Value:TMenuStyle);
begin
      if Fstyle<>value then Fstyle:=value;
end;

{ Get PoupMenu Style. }
Function TMenuOption.GetStyle :TMenuStyle;
begin
     Result:=TMenuStyle(FStyle);
end;

{ Set URLBitmap Display Style. }
Procedure TMenuOption.SetURLDisplay(Value:TURLDisplay);
begin
      if FURLDisplay<>value then FURLDisplay:=value;
end;

{ Get URLBitmap Display Style. }
Function TMenuOption.GetURLDisplay :TURLDisplay;
begin
     Result:=TURLDisplay(FURLDisplay);
end;


{ TWWWBtn97 }

// Set a value in the Glyph property.
// ----------------------------------
Procedure TWWWBtn97.SetGlyph(Value:TBitmap);
begin
     if FGlyph<>value then FGlyph.Assign(Value);
     Invalidate;                    // Redraw the button.
end;

// Set Layout Type.
// ----------------
Procedure TWWWBtn97.SetLayout(Value:TLayout);
begin
      if FLayout<>value then FLayout:=value;
      invalidate;
end;

// Get Layout Type.
// ----------------
Function TWWWBtn97.GetLayout : TLayout;
begin
     Result:=TLayout(FLayout);
end;


{ OnselectURL Event from PopupMenu. }
Procedure TWWWBtn97.SelectURL;
begin
     if Assigned(FOnSelectURL) then FOnSelectURL(Self);
end;

{ Constructor Procedure. }
Constructor TWWWBtn97.Create(AOwner: TComponent);
Begin
     Inherited Create(Aowner);
     // Set components size for IDE Mode.
     ModifFlag:=False;
     ControlStyle := [csCaptureMouse, csClickEvents, csSetCaption];
     Width:=32;
     Height:=22;
     RightWidth:=9;
     Font.color:=Clblack;
     //TMenuOption Initial value.
     FMenu:=TMenuOption.Create;
     FMenu.FItemBmpFolder:=TBitmap.Create;
     FMenu.FItemBmpURL:=TBitmap.Create;
     FMenu.FItemFont:=TFont.Create;
     FMenu.FItemColorSelect:=ClBtnFace;
     FMenu.FItemColorUnSelect:=ClBtnFace;
     FMenu.FItemFont.Color:=ClNavy;
     FMenu.SetItemBmpFolder(FMenu.FitemBmpFolder);
     FMenu.SetItemBmpURL(FMenu.FitemBmpURL);
     FMenu.SetURLDisplay(Only_one_Icon);
     FMenu.SetStyle(Extended);
     // Assign Fglyph with the Glyph property value.
     FGlyph:=TBitmap.create;
     SetGlyph(FGlyph);
     // Create the PopupMenu.
     WMenu := TPopupmenu.create(self);
     //Research the directory of the internet favorites file.
     Registry:=Tregistry.create;
     Registry.RootKey:= HKEY_CURRENT_USER;
     registry.openKey('Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders',false);
     Orig_Folder:=registry.ReadString('Favorites');
     if Orig_Folder <>'' then
        begin
            sList := TList.Create;
             // Get all the links.
             SearchURL(registry.ReadString('Favorites'));
             // Sort the list.
             if SList.Count>0 then
                begin
                     sList.Sort(SortFunction);
                     // Create and set the popupmenu.
                     WMenu := TPopupmenu.create(self);
                     CreateMenu;
                end;
        end;
End;

{ Destructor procedure . }
Destructor TWWWBtn97.Destroy;
Var
   Index : Integer;
Begin
     if Orig_Folder ='' then
        begin
             if Slist.count<>0 then
                for index := 0 to sList.count-1 do
                    begin
                         tempObj := sList[index];
                         tempObj.Destroy;
                    end;
             sList.Destroy;
             WMenu.Destroy;
        end;
     // free all the bitmap memory.
     ImageList.Free;
     TmpBmp.free;
     FGlyph.Free;
     FMenu.FItemFont.Free;
     FMenu.FItemBmpFolder.Free;
     FMenu.FItemBmpURL.Free;
     FMenu.Free;
     Inherited Destroy;
End;

{ Refresh the favorites List. }
Procedure TWWWBtn97.ActuListe;
begin
     If ((Orig_Folder<>'') and (SList.count>0)) then
        begin
             WMenu.free;
             WMenu := TPopupmenu.create(self);     // Create the PopupMenu.
             //Research the main directory of the internet favorites.
             Registry:=Tregistry.create;
             Registry.RootKey:= HKEY_CURRENT_USER;
             registry.openKey('Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders',false);
             Orig_Folder:=registry.ReadString('Favorites');
             Slist.clear;
             // search and Store all the internet links.
             SearchURL(registry.ReadString('Favorites'));
             // Sort list.
             sList.Sort(SortFunction);
             // Create and set the PopupMenu.
             CreateMenu;
             FItemHeight:=19;    // Default PopupMenu size .
             FItemWidth:= 100;
             FDefaultMargin:= GetSystemMetrics(SM_CXMENUCHECK);
             FDefaultHeight:= GetSystemMetrics(SM_CYMENUCHECK);
             ModifFlag:=False; // Put the PopupMenu in OwnerDraw state.
       end;
end;

{ Message WM_COMMAND of PopupMenu.}
Procedure TWWWBtn97.WMCommand(Var Message : TWMCommand);
var
   Index : Integer;
Begin
     Inherited;
     // Research the item selected by user.
     NewItem:=WMenu.FindItem(Message.itemID, fkCommand);
     index:=0;
     TempObj:=Slist.items[0];
     While Newitem.caption<>Tempobj.URLName do
           begin
                inc(index);
                TempObj:=Slist.items[index];
           end;
     FURLNAme:=TempObj.URLName;
     FURLPath:=TempObj.URLPath;
     SelectURL; // Execute OnSelectURL Event.
end;

{ Message WM_MEASUREITEM of Popupmenu. }
procedure TWWWBtn97.WMMeasureItem(var Message: TWMMeasureItem);
Var
   Item: TMenuItem;
begin
     Canvas.Handle:= GetDC(WMenu.WindowHandle);
     Canvas.Font:= FMenu.FItemFont;  //Assign font used for MenuItem.
      with Message.MeasureItemStruct^ do
          begin
               // Research the item selected.
               Item:= WMenu.FindItem(itemID, fkCommand);
               // Get the height and the width of item.
               itemHeight := FitemHeight+2;
               itemWidth:= CalcMenuWidth(Item);
               Message.Result:= longint(True);
          end;
    ReleaseDC(WMenu.WindowHandle, Canvas.Handle);
    Canvas.Handle:= 0;
end;

{ Message WM_DRAWITEM of PopupMenu. }
procedure TWWWBtn97.WMDrawItem(var Message: TWMDrawItem);
Var
   Canvas : TCanvas;
   item   : TMenuItem;
   CenterHeight : Integer;
Begin
     With Message.DrawItemStruct^ do
          Begin
               Canvas:=TCanvas.Create;   // Create the canvas.
               Canvas.Handle := hDC;     // handle.canvas = Menu.canvas.
               Item:= WMenu.FindItem(itemID, fkCommand); // research the item.
               Canvas.Font.Assign(FMenu.FItemFont);     // Font Menu Type.
               // Selected state.
               If ((ItemState And ods_Selected) <> 0) Then
                  begin
                       Canvas.Pen.Color := FMenu.FItemColorSelect;    // Pen color .
                       Canvas.Brush.Color := FMenu.FItemColorSelect; // Brush color.
                       Canvas.Font.color:=FMenu.FFontSelectColor;
                       Canvas.fillrect(RCitem);
                       If FMenu.FBorderStyle=bsRaised then frame3D(canvas,RCItem,clgray,clwhite,1);
                       If FMenu.FBorderStyle=bsLowered then frame3D(canvas,RCItem,clwhite,clgray,1);
                       // Draw icon of the item .
                       if FMenu.FborderStyle<>bsnone then Dec(Rcitem.left);
                       If item.tag=1 then  //If a Folder Item.
                          begin
                               CenterHeight:=(Rcitem.Top+((Rcitem.bottom-Rcitem.top) div 2)
                                              -(FMenu.FItemBmpFolder.Height div 2));
                               Canvas.brushCopy( Bounds(RCItem.Left+2,CenterHeight,16,16),
                                                 FMenu.FItemBmpFolder,Bounds(0,0,16,16),
                                                 FMenu.FItemBmpFolder.Canvas.Pixels[0,0]);
                          end
                       else               //If a URL Item.
                           begin
                                CenterHeight:=(Rcitem.Top+((Rcitem.bottom-Rcitem.top) div 2)
                                              -(FMenu.FItemBmpURL.Height div 2));
                                Canvas.brushCopy( Bounds(RCItem.Left+2,CenterHeight,16,16),
                                                  FMenu.FItemBmpURL,Bounds(0,0,16,16),
                                                  FMenu.FItemBmpURL.Canvas.Pixels[0,0]);
                           end;
                  end
               else // Normal State (Not selected).
                   begin
                        Canvas.Pen.Color := FMenu.FItemColorUnselect;  // Pen color.
                        Canvas.Brush.Color := FMenu.FItemColorUnselect;// Brush color.
                        Canvas.Fillrect(RCItem);        // delete item line.
                        // draw icon of the item.
                        If item.tag=1 then  //If a Folder Item.
                           begin
                                CenterHeight:=(Rcitem.Top+((Rcitem.bottom-Rcitem.top) div 2)
                                               -(FMenu.FItemBmpFolder.Height div 2));
                                Canvas.brushCopy( Bounds(RCItem.Left+2,CenterHeight,16,16),
                                                  FMenu.FItemBmpFolder,Bounds(0,0,16,16),
                                                  FMenu.FItemBmpFolder.Canvas.Pixels[0,0]);
                           end
                        else
                        If FMenu.FURLDisplay=All_Icon then
                           begin
                                CenterHeight:=(Rcitem.Top+((Rcitem.bottom-Rcitem.top) div 2)
                                               -(FMenu.FItemBmpURL.Height div 2));
                                Canvas.brushCopy( Bounds(RCItem.Left+2,CenterHeight,16,16),
                                                  FMenu.FItemBmpURL,Bounds(0,0,16,16),
                                                  FMenu.FItemBmpURL.Canvas.Pixels[0,0]);
                           end;
                   end;
               If FMenu.FItemBmpFolder.Width<FMenu.FItemBmpURL.Width then
                  OffSetWidth:=FMenu.FItemBmpURL.Width+5
               else OffSetWidth:=FMenu.FItemBmpFolder.Width+5;
               If ((FMenu.FItemBmpFolder.Empty=True) and (FMenu.FItemBmpURL.Empty=True)) then
                  OffsetWidth:=20;
               Inc(RCItem.Left,OffsetWidth);
               DrawText( Canvas.Handle,PChar(item.caption),Length(item.caption),
                               RCItem,dt_Left or dt_singleline or dt_vcenter);
               Dec(RCItem.Left,OffsetWidth+1);
          End;
End;

{ Calculate the max Width of PopupMenu and this SubMenu.}
function TWWWBtn97.CalcMenuWidth(Item : TMenuItem) : Integer;
Var
   i, MaxText, TmpTextWidth : Integer;
   ParentItem : TMenuItem;
begin
     ParentItem:=Item.parent;
     MaxText:= 0;
     for i:=0 to (ParentItem.Count - 1) do
         begin
              // Get the width of the text item.
              TmpTextWidth:=Canvas.TextWidth(ParentItem[i].Caption);
              if (MaxText<TmpTextWidth) then MaxText:=TmpTextWidth;
         end;
     Result:=MaxText + FDefaultMargin + 20;  // Return the maw width find.
end;

{ Calculate the max Height for MenuItem. }
Procedure TWWWBtn97.CalcHeightItem;
var
   Values : Array[1..3] Of Byte;
   TestOk : Boolean;
   i : Byte;
begin
     Values[1]:=FMenu.FItemBmpFolder.Height; //Bitmap Folder Height.
     Values[2]:=FMenu.FItemBmpURL.Height;    //Bitmap URL Height
     Values[3]:=FMenu.FItemFont.size - FMenu.FItemFont.Height-3;  //Font Height.
     TestOk:=False;
     i:=1;
     While TestOk=False do
           begin
                If ( (values[i]>=Values[1]) and
                     (values[i]>=Values[2]) and
                     (values[i]>=Values[3])) then TestOk:=True
                Else Inc(i);
           end;
     FItemHeight:=Values[i];
     FItemWidth:= 100;
     FDefaultMargin:= GetSystemMetrics(SM_CXMENUCHECK);
     FDefaultHeight:= GetSystemMetrics(SM_CYMENUCHECK);
end;

{ Change popupmenu in OwnerDraw state. }
procedure TWWWBtn97.ModifyMenuTree(MenuItems : TMenuItem);
Var
   i : Integer;
begin
     for i:= 0 to MenuItems.Count - 1 do  // For all items.
         begin
              If MenuITems[i].Enabled then
                 begin
                      // For all SubMenus.
                      ModifyMenuTree(MenuItems[i]);
                      // Modification for OwnerDraw mode.
                      ModifyMenu( WMenu.Handle, MenuItems[i].Command,
                                  MF_OWNERDRAW or MF_BYCOMMAND,
                                  MenuItems[i].Command, Pointer(Self));
                end;
         end;
     CalcHeightItem;
end;

{ Create all the submenu. }
Function TWWWBtn97.CreateSubMenu : Boolean;
var
   i          : Integer;
   Car        : String[1];
   Dir1       : String;
   nbre,loop3       : Integer;
begin
     Result:=False;
     Nbre:=0;
     For i:=0 to length(TempObj.rep) do
         begin
              Car:=Copy(TempObj.Rep,i,1);
              If car='\' then inc(nbre);
         end;
     loop3:=0;
     For i:=0 to length(TempObj.rep) do
         begin
              Car:=Copy(TempObj.Rep,i,1);
              If car='\' then
                 begin
                      inc(loop3);
                      // Get the directory name
                      Dir1:=Copy(TempObj.Rep,0,i-1);
                      Dir1:=Copy(TempObj.Rep,Length(Dir1)+2,Length(TempObj.Rep));
                      If ((Nbre=1)) then // First subMenu
                         begin
                              // Other subMenu.
                              subItem:=TMenuItem.Create(NewItem);
                              subItem.Caption:=Dir1; // Directory Name.
                              NewItem.insert(0,SubItem);
                              DirItem:=SubItem;
                              Subitem.tag:=1; // Tag = 1 , icone menu (Rep)
                         end
                      else
                          begin
                               if loop3=Nbre then  // Other subMenu.
                                  begin
                                       SubItem:=TMenuItem.Create(DirItem);
                                       SubItem.Caption:=Dir1;
                                       DirItem.insert(0,SubItem);
                                       Diritem:=Subitem;
                                       Diritem.tag:=1;  // Tag = 1 , icone menu (Rep).
                                  end;
                          end;
                      Result:=True; // SubMenus found and created.
                 end;
         end;
end;

{ Create the Menu with the internet favorites file found.}
Procedure TWWWBtn97.createMenu;
var
   nom             : String;
   Loop2,loop,Flag : Boolean;
   i : integer;
   FolderNom :String;
begin
     loop:=false;
     nom:=':';
     i:=0;
     While i<= Slist.count-1 do
           begin
                TempObj:=Slist.items[i];
                If ((TempObj.Rep<>'')) then Nom:=TempObj.Rep; // New Directory.
                If ((TempObj.Rep=Nom)) then // If Record = Repertoire
                       begin
                            Loop2:=False;
                            If CreateSubMenu then Loop2:=True; // SubMenu Created.
                            If loop2=True then // If there are subMenus.
                               begin
                                    While ((TempObj.Rep=Nom)) do
                                          begin
                                               if TempObj.URLName<>'' then
                                                  begin
                                                       // URL File of the directory.
                                                       SubItem:=TMenuItem.Create(DirItem);
                                                       SubItem.Caption:=TempObj.URLNAme;
                                                       DirItem.Add(SubItem);
                                                  end
                                               else   //Folder with URLName=''.
                                                   begin
                                                        // Empty Folder ?.
                                                        if i<=Slist.count-1 then
                                                           begin
                                                                FolderNom:=Tempobj.Rep;
                                                                Tempobj:=slist.items[i+1];
                                                                if FolderNom<>tempobj.rep then
                                                                   begin
                                                                        SubItem:=TMenuItem.Create(DirItem);
                                                                        SubItem.Caption:='( Empty )';
                                                                        Subitem.Enabled:=False;
                                                                        DirItem.Add(SubItem);
                                                                   end;
                                                                Tempobj:=slist.items[i];
                                                           end;
                                                   end;
                                               inc(i);
                                               If i<=Slist.count-1 then TempObj:=Slist.items[i]
                                               else nom:=':';
                                               Loop:=True;
                                          end;
                               end
                            Else // Not submenus.
                                begin
                                     // Create the Main directory.
                                     NewItem:=TMenuItem.Create(WMenu);
                                     NewItem.Caption:=TempObj.Rep;
                                     WMenu.Items.Add(NewItem);
                                     Newitem.tag:=1; // Tag = 1 , icone menu (Rep)
                                     // Empty Folder ?.
                                     if i<=Slist.count-1 then
                                        begin
                                             FolderNom:=Tempobj.Rep;
                                             Tempobj:=slist.items[i+1];
                                             if FolderNom<>tempobj.rep then
                                                begin
                                                     SubItem:=TMenuItem.Create(Newitem);
                                                     SubItem.Caption:='( Empty )';
                                                     Subitem.Enabled:=False;
                                                     NewItem.Add(SubItem);
                                                end;
                                             Tempobj:=slist.items[i];
                                        end;
                                end;
                            Flag:=False;
                            while ((TempObj.Rep=Nom) and (flag=False)) do
                                  begin
                                       If TempObj.URLName<>'' then
                                          begin
                                               // Create the URL file of the First Directory.
                                               subItem:=TMenuItem.Create(NewItem);
                                               subItem.Caption:=TempObj.URLNAme;
                                               NewItem.Add(SubItem);
                                          end;
                                       // End Of List ?
                                       inc(i);
                                       if i > slist.count-1 then flag:=true
                                       else tempobj:=slist.items[i];
                                       Loop:=True;
                                  end;
                       end;
                // End Of List ? or Value incremented before ?.
                If loop=false then inc(i);
                Loop:=False;
           end;
     // Created URL File of the main Directory.
     i:=0;
     TempObj:=Slist.items[0];
     While ((TempObj.rep='') and (i<slist.count)) do
           begin
                NewItem:=TMenuItem.Create(WMenu);
                NewItem.Caption:=TempObj.URLName;
                WMenu.Items.Add(NewItem);
                inc(i);
                if i<slist.count then TempObj:=Slist.items[i];
           end;
End;

// Draw a bitmap with Disabled mode.
// ---------------------------------
procedure TWWWBtn97.DrawGrayGlyph(Canvas: TCanvas; bmp: TBitmap ; x, y: Integer);
var
   MonoBmp,TmpBmp1 : TBitmap;
   Imagelist1 :Timagelist;
   NewRect : Trect;
begin
     if ((bmp.width=0) and (bmp.height=0)) then exit;   //No Bitmap.
     ImageList1 := TImageList.CreateSize(bmp.Width, bmp.Height);
     ImageList1.DrawingStyle := dstransparent;
     ImageList1.BkColor := clnone;
     ImageList1.AddMasked(Bmp,Bmp.Canvas.Pixels[0,0]);
     TmpBmp1:=Tbitmap.create;                         //Create Tempory Bitmap.
     Imagelist1.getbitmap(0,TmpBmp1);
     NewRect := Rect(0, 0, bmp.width,Bmp.height);
     TmpBmp1.Canvas.Brush.Color := clBtnFace;
     MonoBmp := TBitmap.Create;                      //Create Monochrome Bitmap.
     MonoBmp.Monochrome := True;
     MonoBmp.Width := bmp.width;
     MonoBmp.Height := bmp.Height;
     with TmpBmp1 do
          begin
               // Generate the mask in MonoBmp with FTransparentColor.
               SetBkColor(Canvas.Handle,Canvas.pixels[0,0]);
               BitBlt(MonoBmp.Canvas.Handle,0,0,Width,Height,Canvas.Handle,
                      0,0,SRCCOPY);
               // and White Color.
               SetBkColor(Canvas.Handle,clWhite);
               BitBlt(MonoBmp.Canvas.Handle,0,0,Width,Height,Canvas.Handle,
                      0,0,SRCPAINT);
               // and clSilver.
               SetBkColor(Canvas.Handle,clSilver);
               BitBlt(MonoBmp.Canvas.Handle,0,0,Width,Height,Canvas.Handle,
                      0,0,SRCPAINT);
               // Fill TmpBmp with clbtnFace color.
               Canvas.Brush.Color:=clBtnFace;
               Canvas.FillRect(NewRect);
               // Copy MonoBmp to TmpBmp with clbtnHighlight color.
               Canvas.Brush.Color:=clBtnHighlight;
               SetTextColor(Canvas.Handle,clBlack);
               SetBkColor(Canvas.Handle,clWhite);
               BitBlt(Canvas.Handle,1,1,Width-1,Height-1,MonoBmp.Canvas.Handle,
                      0,0,$00B8074A);
               // Add MonoBmp to TmpBmp with clbtnShadow color.
               Canvas.Brush.Color:=clBtnShadow;
               SetTextColor(Canvas.Handle,clBlack);
               SetBkColor(Canvas.Handle,clWhite);
               BitBlt(Canvas.Handle,0,0,Width,Height,MonoBmp.Canvas.Handle,
                      0,0,$00B8074A);
          end;
     // draw Bitmap for disabled state aspect.
     ImageList1.Draw(Canvas,x,y,ImageList1.AddMasked(TmpBmp1,tmpBmp1.canvas.pixels[0,0]));
     // Free ressource used.
     MonoBmp.Free;
     TmpBmp1.Free;
     Imagelist1.free;
end;

// Draw the PoupMark of the Button.
// --------------------------------
Procedure TWWWBtn97.DrawPopupMark (state : Boolean);
var
   X,Y : Integer;
begin
     x:=RectR.left + 4;
     y:=RectR.top + (RectR.Bottom div 2);
     If State then
        begin
             Canvas.Pen.color:=Font.color;
             Canvas.polyline([ Point(x-2,y-1),Point(x+2,y-1),
                               Point(x+2,y-1),Point(x,y+1),
                               Point(x,y+1),Point(x-2,y-1) ]);
             Canvas.Pixels[x,y] := clblack;
        end
     else
         begin
              Canvas.Pen.color:=ClbtnHighlight;
              Canvas.polyline([ Point(x-2,y),Point(x+2,y),
                                Point(x+2,y),Point(x,y+2),
                                Point(x,y+2),Point(x-2,y) ]);
              Canvas.Pixels[x,y+1] := ClbtnHighlight;
              Canvas.Pen.color:=ClbtnShadow;
              Canvas.polyline([ Point(x-2,y-1),Point(x+2,y-1),
                                Point(x+2,y-1),Point(x,y+1),
                                Point(x,y+1),Point(x-2,y-1) ]);
              Canvas.Pixels[x,y] := ClbtnShadow;
         end;
end;

// Draw a bitmap with Enabled mode.
// --------------------------------
procedure TWWWBtn97.DrawGlyph(Canvas:TCanvas; bmp:TBitmap; x,y:Integer);
var
   bmp1 : Tbitmap;
begin
     bmp1:=tbitmap.create;
     if imagelist<>NIL then imagelist.GetBitmap(1,bmp1);
     If ((imageList=NIL) or (bmp1<>bmp)) then
        begin
             Canvas.brush.style := bsClear;
             if ((bmp.width=0) and (bmp.height=0)) then exit;
             ImageList := TImageList.CreateSize(bmp.Width, bmp.Height);
             ImageList.DrawingStyle := dstransparent;
             ImageList.BkColor := clNone;
             TmpBmp := TBitmap.Create;
             TmpBmp.Assign(bmp);
        end;
     ImageList.Draw(Canvas,x,y,ImageList.AddMasked(TmpBmp,TmpBmp.Canvas.Pixels[0,0]));
     bmp1.free;
end;


// Draw Caption of the main button.
// --------------------------------
Procedure TWWWBtn97.DrawCaption(Layout : TLayout ; Mode : Boolean);
Begin
     Canvas.brush.style := bsClear;
     If Mode=True then Canvas.font.color:= Font.color
     else Canvas.font.color:= ClbtnHighlight;
     Case FLayout Of
       GlyphTop : Begin
                       Dec(RectL.Bottom,2);
                       DrawText( Canvas.Handle,PChar(caption),Length(caption),
                         RectL,dt_SingleLine or Dt_Center or Dt_Bottom);
                       If (Not Mode) then
                          begin
                               Canvas.font.color:= ClbtnShadow;
                               Dec(RectL.left,1);
                               Dec(RectL.bottom,1);
                               DrawText( Canvas.handle,PChar(Text),Length(Text),
                                 RectL,dt_SingleLine or Dt_Center or Dt_Bottom);
                               Inc(RectL.left,1);
                               Inc(RectL.bottom,1);
                          end;
                       Inc(RectL.Bottom,2);
                  end;
       GlyphBottom : Begin
                          Inc(RectL.top,2);
                          DrawText( Canvas.Handle,PChar(caption),Length(caption),
                            RectL,dt_SingleLine or Dt_Center or Dt_Top);
                          If (Not Mode) then
                             begin
                                  Canvas.font.color:= ClbtnShadow;
                                  Dec(RectL.left,1);
                                  Dec(RectL.Top,1);
                                  DrawText( Canvas.Handle,PChar(caption),Length(caption),
                                    RectL,dt_SingleLine or Dt_Center or Dt_Top);
                                  Inc(RectL.left,1);
                                  Inc(RectL.Top,1);
                             end;
                          Dec(RectL.top,2);
                     end;
       GlyphLeft : Begin
                        Inc(RectL.left,FGlyph.width + 10);
                        DrawText( Canvas.Handle,PChar(caption),Length(caption),
                          RectL,dt_SingleLine or Dt_VCenter or Dt_Left );
                        If (Not Mode) then
                           begin
                                Canvas.font.color:= ClbtnShadow;
                                Dec(RectL.left,1);
                                Dec(RectL.Top,1);
                                DrawText( Canvas.Handle,PChar(caption),Length(caption),
                                  RectL,dt_SingleLine or Dt_VCenter or Dt_Left );
                                Inc(RectL.left,1);
                                Inc(RectL.Top,1);
                           end;
                        Dec(RectL.left,FGlyph.width + 10);
                   end;
       GlyphRight : Begin
                         Inc(RectL.left,5);
                         DrawText( Canvas.Handle,PChar(caption),Length(caption),
                           RectL,dt_SingleLine or Dt_VCenter or Dt_Left );
                         If (Not Mode) then
                            begin
                                 Canvas.font.color:= ClbtnShadow;
                                 Dec(RectL.left,1);
                                 Dec(RectL.Top,1);
                                 DrawText( Canvas.Handle,PChar(caption),Length(caption),
                                   RectL,dt_SingleLine or Dt_VCenter or Dt_Left );
                                 Inc(RectL.left,1);
                                 Inc(RectL.Top,1);
                            end;
                         Dec(RectL.left,5);
                    End;
     end;
end;

// Draw the Main Button.
// ---------------------
Procedure TWWWBtn97.DrawBtn( Mode : Byte);
var
   CenterX,CenterY : Byte;
begin
     Canvas.font:=Font;
     With Canvas do
          begin
               // Get the rect of Left button.
               RectL:=GetClientRect;
               SetRect(RectL,0,0,Width-9,Height);
               // Get the rect of Right button.
               RectR:=GetClientRect;
               SetRect(RectR,Width-9,0,Width,Height);
               CenterX:=((RectL.Right div 2) - (FGlyph.Width Div 2));
               CenterY:=((RectL.Bottom Div 2) - (FGlyph.Height Div 2));
               If Enabled then
                  begin
                       DrawPopupMark(True);
                       If ((Caption='') and (Fglyph.empty=False)) then
                          DrawGlyph(Canvas,FGlyph,CenterX,CenterY);
                       canvas.brush.style:=bsclear;
                       If FGlyph.Empty=True then
                          DrawText(handle,PChar(caption),Length(caption),RectL,
                          dt_SingleLine or Dt_VCenter or Dt_Center);
                       If ((Caption<>'') and (FGlyph.Empty=False)) then
                          begin
                               // Draw Caption & Glyph with # Positions.
                               DrawCaption(FLayout,True);
                               Case FLayout Of
                                 GlyphTop    : DrawGlyph(Canvas,FGlyph,CenterX,RectL.Top + 4);
                                 GlyphBottom : DrawGlyph(Canvas,FGlyph,CenterX,(RectL.Bottom-4-FGlyph.Height));
                                 GlyphLeft   : DrawGlyph(Canvas,FGlyph,RectL.Left+5,CenterY);
                                 GlyphRight  : DrawGlyph(Canvas,FGlyph,( RectL.Left+textwidth(caption)+10),CenterY);
                               end;
                          end;
                  end
               else
                   begin
                        DrawPopupMark(False);
                        If ((Caption='') and (Fglyph.empty=False)) then
                           DrawGrayGlyph(Canvas,FGlyph,CenterX,CenterY);
                        If FGlyph.Empty=True then
                           begin
                                canvas.brush.style:=bsclear;
                                Canvas.Font.color:= ClbtnHighlight;
                                DrawText(handle,PChar(Caption),Length(Caption),RectL,
                                    dt_SingleLine or Dt_VCenter or Dt_Center);
                                Dec(RectL.left,2);
                                Dec(RectL.Top,2);
                                Canvas.font.color:=ClbtnShadow;
                                DrawText(handle,PChar(Caption),Length(Caption),RectL,
                                    dt_SingleLine or Dt_VCenter or Dt_Center);
                                Inc(RectL.left,2);
                                Inc(RectL.Top,2);
                           end;
                       If ((Caption<>'') and (FGlyph.Empty=False)) then
                          begin
                               // Draw Caption & Glyph with # Positions.
                               DrawCaption(FLayout,False);
                               Case FLayout Of
                                 GlyphTop    : DrawGrayGlyph(Canvas,FGlyph,CenterX,RectL.Top + 4);
                                 GlyphBottom : DrawGrayGlyph(Canvas,FGlyph,CenterX,(RectL.Bottom-4-FGlyph.Height));
                                 GlyphLeft   : DrawGrayGlyph(Canvas,FGlyph,RectL.Left+5,CenterY);
                                 GlyphRight  : DrawGrayGlyph(Canvas,FGlyph,( RectL.Left+textwidth(caption)+10),CenterY);
                               end;
                          end;
                   end;
               // Draw the button.
               Case Mode of
                    Normal : Begin // selected state.
                                  Frame3D(Canvas,RectL,clBtnHighlight,clBtnShadow,1);
                                  Frame3D(Canvas,RectR,clBtnHighlight,clBtnShadow,1);
                            End;
                    LeftDown: Begin // Left button click.
                                   Frame3D(Canvas,RectL,clBtnShadow,clBtnHighLight,1);
                                   Frame3D(Canvas,RectR,clBtnHighLight,clBtnShadow,1);
                                End;
                    RightDown: Begin // Right button click.
                                    Frame3D(Canvas,RectL,clBtnHighLight,clBtnShadow,1);
                                    Frame3D(Canvas,RectR,clBtnShadow,clBtnHighLight,1);
                                 End;
               end;
          end;
End;

// Modify the inherited paint procedure of the button.
// ---------------------------------------------------
Procedure TWWWBtn97.Paint;
Begin
     Inherited;
     If Enabled then
        begin
             If ((csDesigning in ComponentState) or
                (HasMouse and (not StillDown))) then DrawBtn(Normal);
             If (HasMouse and StillDown) then
                If MainButton then DrawBtn(LeftDown)
                else DrawBtn(RightDown);
             If (Not HasMouse) and StillDown then DrawBtn(Normal);
             If (Not HasMouse) then DrawBtn(NoSel);
        end
     else Drawbtn(Normal);
end;

{ Research and create the list of the favorites files found. }
Procedure TWWWBtn97.SearchURL(Folder : String);
var
   Flag      : Integer;
   SearchRec : TSearchRec;
   fichier   : Tinifile;
begin
     // First File.
     Flag := FindFirst(Folder+'\*.*', faAnyFile, SearchRec);
     // Research other file.
     while Flag = 0 do
           begin
                // don't get the special directory ('.' et '..');
                if ((SearchRec.Name <> '.' ) and (SearchRec.Name <> '..')) then
                   // change directory.
                   if (SearchRec.Attr and fadirectory > 0) then
                      begin
                           if not (SearchRec.Attr and fasysfile > 0) then
                               begin
                           tempObj := TURLrec.Create;
                           tempobj.Rep:=copy(Folder+'\'+SearchRec.Name,length(Orig_Folder)+2,length(Folder+'\'+SearchRec.Name));
                           TempObj.URLName:='';
                           TempObj.URLPath:='';
                           sList.Add(tempObj);
                               end;
                           searchURL(Folder+'\'+SearchRec.Name);
                      end
                   else
                       begin
                            // Get the file extension.
                            if (UpperCase(ExtractFileExt(Searchrec.Name)) = '.URL') then
          	               begin
                                    begin
                                         tempObj := TURLrec.Create;
                                         TempObj.Rep:=copy(folder,length(Orig_Folder)+2,length(folder));
                                         fichier := Tinifile.create(Folder+'\'+SearchRec.name);
                                         TempObj.URLName:=copy(SearchRec.Name,0,length(SearchRec.Name)-3);
                                         TempObj.URLPath:=fichier.ReadString('InternetShortcut','URL','non trouv');
                                         sList.Add(tempObj);
                                    end;
                               end;
                       end;
                   // other file.
                   Flag := FindNext(SearchRec);
           end;
end;

{ pointer procedure for sort the list. }
function SortFunction( item1, item2 : Pointer ) : Integer;
var
   tempObj1 : TURLrec;
   tempObj2 : TURLrec;
begin
     Result:=0;
     tempObj1 := TURLrec( item1 );
     tempObj2 := TURLrec( item2 );
     if tempObj1.rep < tempObj2.rep then result:=-1;
     if tempObj1.rep > tempObj2.rep then result:=1;
     if tempObj1.rep = tempObj2.rep then
        begin
             if ((tempobj1.URLName < tempobj2.URLName)) then result:=-1;
             if ((tempobj1.URLName > tempobj2.URLName)) then result:=1;
             if ((tempobj1.URLName = tempobj2.URLName)) then result:=0;
        end;
end;

{ Mouse Message "OnEnter" on the button. }
procedure TWWWBtn97.CMMouseEnter(var Message: TMessage);
Begin
    If Enabled then
       begin
            HasMouse:=True;
            Invalidate;    // Redraw button.
       End;
End;

{ Mouse Message "OnLeave" on the button. }
procedure TWWWBtn97.CMMouseLeave(var Message: TMessage);
Begin
    If Enabled then
       begin
            HasMouse:=False;
            Invalidate;     // Redraw button.
       End;
End;

{ Mouse event "OnMouseDown" of the button. }
Procedure TWWWBtn97.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Begin
    If Enabled then
       begin
            Inherited MouseDown(Button, Shift, X, Y);
            if button=mbleft then // If is left button.
               begin
                    StillDown:=True;
                    If X<Width-RightWidth then MainButton:=True
                    Else MainButton:=False;
                    Invalidate;
               end;
       end;
End;

{ Mouse event "OnMouseUp" of the button. }
Procedure TWWWBtn97.MouseUp( Button: TMouseButton; Shift: TShiftState;X, Y: Integer);
var
   P,popupPoint :Tpoint;
Begin
    If Enabled then
       begin
            Inherited MouseUp(Button, Shift, X, Y);
            if button=mbleft then // If is th left button.
               begin
                    StillDown:=False;
                    // Get button coords for displaying the popupmenu.
                    PopupPoint := Point(width-RightWidth, Height);
                    PopupPoint := ClientToScreen(PopupPoint);
                    if ((not Mainbutton) and (hasmouse))  then
                       begin
                            // Modify Menu if option was choose.
                            If FMenu.GetStyle<>Standard then
                               If ModifFlag=False then ModifyMenuTree(Wmenu.items);
                            ModifFlag:=True;
                            // show Popupmenu.
                            trackpopupmenu( Wmenu.handle,TPM_LEFTALIGN,PopupPoint.X,
                                            PopupPoint.Y,0,handle,Nil);
                            // Get mouse coords after click.
                            GetCursorPos(P);
                            P:=ScreenToClient(P);
                            if ( (P.X<RectB.left) or (P.X>RectB.Right) or
                                 (P.Y<RectB.top) or (P.Y>RectB.bottom)) then hasmouse:=false;
                       end;
                       Invalidate; // Redraw button.
                    if Mainbutton then // If is the right button.
                       begin
                            // Refresh list;
                            Actuliste;
                       end;
               end;
       end;
End;

{ Message "Enabled" in DELPHI IDE. }
Procedure TWWWBtn97.CMEnabledChanged(var Msg: TMessage);
Begin
    Inherited;
    Invalidate;
End;

Procedure TWWWBtn97.CMTextChanged(var Msg: TMessage);
Begin
    Inherited;
    Invalidate;
End;

Procedure TWWWBtn97.CMFontChanged(var Msg: TMessage);
Begin
    Inherited;
    Canvas.font:=Font;
    Invalidate;
End;

// Register procedure.
// -------------------
Procedure Register;
begin
     RegisterComponents('Win97', [TWWWBtn97]);
end;

end.
